#pragma once

#include <arviz_godot/lib/avi/core/Settings.h>
#include <arviz_godot/lib/avi/core/SettingsProvider.h>

namespace avi::app
{
    class ApplicationSettings : public avi::core::SettingsProvider
    {
    public:
        explicit ApplicationSettings(avi::core::Settings settings);
        ~ApplicationSettings() override = default;

        [[nodiscard]] const std::string& getStorageIdentifier() const override;

        [[nodiscard]] double getMoveSpeedTechnical() const override;

        [[nodiscard]] double getMoveSpeedPlayful() const override;

        [[nodiscard]] bool isPlayfulInputSmoothed() const override;

        [[nodiscard]] double getSmoothingFactorPlayful() const override;

        [[nodiscard]] double getZoomSensitivity() const override;

        [[nodiscard]] double getOrbitSensitivity() const override;

        [[nodiscard]] double getRollSensitivity() const override;

        [[nodiscard]] double getRollSensitivityPlayful() const override;

        [[nodiscard]] double getMouseSensitivity() const override;

        [[nodiscard]] double getRevisionCycleFrequency() const override;

        [[nodiscard]] bool cameraGravity() const override;

        [[nodiscard]] const std::string& getDefaultProfileName() const override;

        [[nodiscard]] const std::filesystem::path& getProfileDirectory() const override;

        [[nodiscard]] const std::filesystem::path& getScreenshotDirectory() const override;

        [[nodiscard]] const std::filesystem::path& getVideoDirectory() const override;

        avi::core::Settings& getSettings();

    private:
        avi::core::Settings settings;
    };
} // namespace avi::app
