#pragma once

#include <vector>

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/input_map.hpp>
#include <godot_cpp/classes/node.hpp>

#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/core/EventToKeyProvider.h>

namespace avi::app
{
    class KeyInputEventDispatch : public godot::Node, public avi::core::EventToKeyProvider
    {
        GDCLASS(KeyInputEventDispatch, Node)

    public:
        static void _bind_methods();

        KeyInputEventDispatch();
        virtual ~KeyInputEventDispatch() = default;

        void _unhandled_input(godot::Ref<godot::InputEvent> const& event) override;

        void hookup(avi::core::EventInvokingSystem& events);

        std::optional<godot::InputEventKey*>
        getEventKey(std::string const& eventKey) const override;

    private:
        avi::core::EventInvokingSystem* eventSystem = nullptr;

        struct Event
        {
            const char* inputAction;
            const std::string eventKey;
        };

        std::vector<Event> pressedEvents;
        std::vector<Event> releasedEvents;
    };
} // namespace avi::app
