#pragma once

#include <arviz_godot/lib/avi/connection/ElementStorage.h>

namespace avi::connection
{
    class MockStorage : public avi::connection::ElementStorage
    {
    public:
        class MockComponent : public avi::connection::Component
        {
        public:
            bool isConnected() const override;

            armarx::viz::StorageInterfacePrx getStorageInterface() const override;
        };

    public:
        MockStorage();
        ~MockStorage() override = default;

        StorageAdapter::LayerUpdates getNext() override;

        bool isConnected() const override;

        bool isLive() const override;

        std::string recordReplay(const std::string& name) override;

        void endRecording() override;

        bool isRecording() const override;
        recordingInfo getRecordingInformation(const std::string name) override;

        std::vector<std::string> getAllReplays() override;

        std::filesystem::path getRecordingPath() override;

        void useLiveTiming() override;

        void useReplayTiming(const std::string& replay,
                             std::shared_ptr<avi::connection::Clock> clock) override;

        void addInteraction(Interaction interaction) override;

        void setStandardParameter(IceUtil::Handle<armarx::viz::data::Element> element,
                                  std::basic_string<char> id);

    private:
        MockComponent component{};
        bool live{true};

        bool lSwitch = false;
    };
} // namespace avi::connection
