#pragma once

#include <vector>

#include <RobotAPI/components/ArViz/ArVizStorage.h>

#include "Interaction.h"

namespace avi::connection
{
    class StorageAdapter
    {
    public:
        struct LayerUpdates {
            armarx::viz::data::LayerUpdates updates;
            bool clearScene;
        };

        virtual LayerUpdates getLayerUpdates() = 0;

        virtual std::vector<std::string> getAllReplays() = 0;

        virtual void setup() = 0;

        virtual bool finishedProcessing() = 0;

        virtual ~StorageAdapter() = default;

        virtual void setInteraction(std::vector<avi::connection::Interaction> interactions) = 0;
    };
} // namespace avi::connection
