#pragma once

#include <functional>
#include <memory>
#include <vector>

#include <godot_cpp/variant/aabb.hpp>
#include <godot_cpp/variant/transform3d.hpp>

#include <arviz_godot/lib/avi/connection/SentElementType.h>
#include <arviz_godot/lib/avi/core/Layer.h>

namespace avi::core
{
    class Element
    {
    public:
        virtual ~Element() = default;

        virtual avi::connection::SentElementType getType() = 0;

        virtual std::string getName() = 0;

        virtual avi::core::Layer* getLayer() = 0;

        virtual godot::AABB getVolume() = 0;
        virtual godot::Transform3D getTransform() = 0;

        virtual bool isSelectable() = 0;

        virtual bool isManipulable() = 0;

        virtual bool hasContextMenu() = 0;

        virtual void setDeselectCallback(std::function<void()> callback);

        virtual std::vector<std::string> getInteractions() = 0;
    };
} // namespace avi::core
