#pragma once

#include <functional>
#include <vector>

#include <godot_cpp/variant/vector2.hpp>
#include <godot_cpp/godot.hpp>

namespace avi::core
{

    class InterfaceUtility
    {
    public:
        virtual ~InterfaceUtility() = default;

        virtual void openSelectionMenu(godot::Vector2 mousePosition,
                                       std::vector<std::string> interactions,
                                       std::function<void(int64_t)> callback) = 0;

        virtual void openTextInputPrompt() = 0;

        virtual void requestHiddenUI() = 0;

        virtual void requestVisibleUI() = 0;
    };
} // namespace avi::core
