#pragma once

#include <filesystem>

namespace avi::core
{
    class SettingsProvider
    {
    public:
        virtual ~SettingsProvider() = default;

        virtual const std::string& getStorageIdentifier() const = 0;
        virtual double getMoveSpeedTechnical() const = 0;
        virtual double getMoveSpeedPlayful() const = 0;
        virtual bool isPlayfulInputSmoothed() const = 0;
        virtual double getSmoothingFactorPlayful() const = 0;
        virtual double getZoomSensitivity() const = 0;
        virtual double getOrbitSensitivity() const = 0;
        virtual double getRollSensitivity() const = 0;
        virtual double getRollSensitivityPlayful() const = 0;
        virtual double getMouseSensitivity() const = 0;
        virtual double getRevisionCycleFrequency() const = 0;
        virtual bool cameraGravity() const = 0;
        virtual const std::string& getDefaultProfileName() const = 0;
        virtual const std::filesystem::path& getProfileDirectory() const = 0;
        virtual const std::filesystem::path& getScreenshotDirectory() const = 0;
        virtual const std::filesystem::path& getVideoDirectory() const = 0;
    };
} // namespace avi::core
