#pragma once

#include <string>

#include <godot_cpp/godot.hpp>
#include <godot_cpp/variant/vector3.hpp>
#include <godot_cpp/variant/basis.hpp>


namespace avi::core::utilities
{
    real_t
    signed_angle(const godot::Vector3& from, const godot::Vector3& to, const godot::Vector3& axis);

    godot::Basis scaled_local(const godot::Basis& basis, const godot::Vector3& scale);

    bool is_equal_approx(const godot::Vector3 a, const godot::Vector3 b);

    godot::Vector3 normalized_or_zero(const godot::Vector3& x);

    std::string to_string(const godot::String& string);

} // namespace avi::core::utilities
