#pragma once

#include <godot_cpp/classes/control.hpp>
#include <godot_cpp/classes/item_list.hpp>
#include <godot_cpp/godot.hpp>

#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>
#include <arviz_godot/lib/avi/core/EventToKeyProvider.h>

namespace avi::gui
{
    class CameraModeMenu : public godot::ItemList
    {
        GDCLASS(CameraModeMenu, godot::ItemList)

    public:
        static void _bind_methods();

        CameraModeMenu() = default;
        virtual ~CameraModeMenu() = default;

        void _process(double delta) override;

        void _ready() override;

        void setup(avi::core::EventInvokingSystem& invokingSystem,
                   avi::core::EventSubscriptionSystem& eventSubscriptionSystem,
                   avi::core::EventToKeyProvider& eventToKeyProvider);

    private:
        avi::core::EventInvokingSystem* events;

        int modeCount;

        enum Selection
        {
            CAMERA_TECHNICAL = 0,
            CAMERA_PLAYFUL = 1,
        };

        Selection current{CAMERA_TECHNICAL};

        int getSelectedItemID();

        void setActiveManipulator();

        void disableActiveItemText();
    };
} // namespace avi::gui
