#pragma once

#include <godot_cpp/classes/control.hpp>
#include <godot_cpp/classes/check_box.hpp>
#include <godot_cpp/classes/item_list.hpp>
#include <godot_cpp/godot.hpp>

#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>
#include <arviz_godot/lib/avi/core/EventToKeyProvider.h>
#include <arviz_godot/lib/avi/interaction/ManipulationMode.h>
#include <arviz_godot/lib/avi/interaction/Manipulator.h>

namespace avi::gui
{
    class ManipulationMenu : public godot::ItemList
    {
        GDCLASS(ManipulationMenu, godot::ItemList)

    public:
        static void _bind_methods();

        ManipulationMenu();
        virtual ~ManipulationMenu() = default;

        void _process(double delta) override;

        void _ready() override;

        void setup(avi::interaction::Manipulator& manipulator,
                   avi::core::EventSubscriptionSystem& eventSubscriptionSystem,
                   avi::core::EventToKeyProvider& eventToKeyProvider);

    private:
        avi::interaction::Manipulator* manipulator{};

        int manipulatorCount;

        enum Selection
        {
            MANIPULATOR_NONE = 0,
            MANIPULATOR_MOVE = 1,
            MANIPULATOR_ROTATE = 2,
            MANIPULATOR_SCALE = 3,
        };

        ManipulationMode selectionMode;

        int getSelectedItemID();
        void setActiveManipulator();
    };
} // namespace avi::gui
