#include <arviz_godot/lib/avi/core/Detoolifier.h>
#include "OrientationWindow.h"

#include <godot_cpp/classes/button.hpp>

void
avi::gui::OrientationWindow::_bind_methods()
{
    DETOOLIFY;
    godot::ClassDB::bind_method(godot::D_METHOD("_ok"), &OrientationWindow::_ok);
}

void
avi::gui::OrientationWindow::_ready()
{
    DETOOLIFY;
    x = get_node<godot::SpinBox>("Container/Values/X");
    y = get_node<godot::SpinBox>("Container/Values/Y");
    z = get_node<godot::SpinBox>("Container/Values/Z");

    get_node<godot::Button>("Container/Center/Accept")->connect("pressed", godot::Callable(this, "_ok"));
    this->connect("confirmed", godot::Callable(this, "_ok"));
}

void
avi::gui::OrientationWindow::setup(avi::scene::VisualizedScene& scene)
{
    DETOOLIFY;
    this->scene = &scene;
}

void
avi::gui::OrientationWindow::open()
{
    DETOOLIFY;
    godot::Vector3 orientation = scene->getOrientation();

    x->set_value(orientation.x);
    y->set_value(orientation.y);
    z->set_value(orientation.z);

    this->popup_centered();
}

void
avi::gui::OrientationWindow::_ok()
{
    DETOOLIFY;
    godot::Vector3 orientation(x->get_value(), y->get_value(), z->get_value());
    scene->setOrientation(orientation);

    this->hide();
}
