#pragma once

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/spin_box.hpp>
#include <godot_cpp/classes/confirmation_dialog.hpp>

#include <arviz_godot/lib/avi/scene/VisualizedScene.h>

namespace avi::gui
{
    class OrientationWindow : public godot::ConfirmationDialog
    {
        GDCLASS(OrientationWindow, godot::ConfirmationDialog)

    public:
        static void _bind_methods();

        OrientationWindow() = default;
        virtual ~OrientationWindow() = default;

        void _ready() override;

    public:
        void setup(avi::scene::VisualizedScene& scene);

        void open();

    private:
        void _ok();

    private:
        godot::SpinBox* x;
        godot::SpinBox* y;
        godot::SpinBox* z;

        avi::scene::VisualizedScene* scene;
    };
} // namespace avi::gui
