#include <arviz_godot/lib/avi/core/Detoolifier.h>
#include "SelectionMenu.h"

#include <godot_cpp/classes/global_constants.hpp>
#include <godot_cpp/classes/input_event_mouse_button.hpp>

void
avi::gui::SelectionMenu::_bind_methods()
{
    DETOOLIFY;
    godot::ClassDB::bind_method(godot::D_METHOD("sendInteraction", "value"), &avi::gui::SelectionMenu::sendInteraction);
}

void
avi::gui::SelectionMenu::_ready()
{
    DETOOLIFY;
    this->connect("id_pressed", godot::Callable(this, "sendInteraction"));
}

void
avi::gui::SelectionMenu::open(godot::Vector2 mousePosition,
                              std::vector<std::string>& options,
                              std::function<void(int64_t)> callback)
{
    DETOOLIFY;
    this->callback = callback;

    if (this->options == options)
    {
        popup(godot::Rect2(mousePosition.x, mousePosition.y, 10, 10));
        return;
    }

    this->clear();
    this->options = options;

    popup(godot::Rect2(mousePosition.x, mousePosition.y, 10, 10));

    for (auto& option : options)
    {
        this->add_item(option.c_str());
    }

    this->set_size({0, 0});
}

void
avi::gui::SelectionMenu::sendInteraction(godot::Variant)
{
    DETOOLIFY;
    int64_t index = this->get_focused_item();
    if (index < 0)
    {
        return;
    }

    size_t idx = index;

    if (idx < options.size())
    {
        this->callback(this->get_focused_item());
    }
}
