#pragma once

#include <functional>
#include <vector>

#include <godot_cpp/classes/popup_menu.hpp>
#include <godot_cpp/godot.hpp>

namespace avi::gui
{
    class SelectionMenu : public godot::PopupMenu
    {
        GDCLASS(SelectionMenu, godot::PopupMenu)

    public:
        static void _bind_methods();

        SelectionMenu() = default;
        virtual ~SelectionMenu() = default;

        void _ready() override;

        void open(godot::Vector2 mousePosition,
                  std::vector<std::string>& options,
                  std::function<void(int64_t)> callback);

    private:
        std::vector<std::string> options;
        std::function<void(int64_t)> callback;

        void sendInteraction(godot::Variant);
    };
} // namespace avi::gui
