#pragma once

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/window.hpp>

#include <arviz_godot/lib/avi/core/Settings.h>
#include <arviz_godot/lib/avi/gui/VisualOptionTransformer.h>
#include <godot_cpp/classes/popup.hpp>

namespace avi::gui
{
    class SettingsWindow : public godot::Popup
    {
        GDCLASS(SettingsWindow, godot::Popup)

    public:
        static void _bind_methods();

        SettingsWindow() = default;
        virtual ~SettingsWindow() = default;

    public:
        void setup(avi::core::Settings& settings);

        void open();

    private:
        void _change(godot::Variant v);

        void _save();

        void setSavedFlag(bool flag);

    private:
        godot::Button* saveButton{};

        avi::core::Settings* settings{};
        std::vector<std::unique_ptr<avi::core::Option<VisualOptionTransformer>>> options{};
        std::vector<std::function<void()>> setters{};
    };
} // namespace avi::gui
