#pragma once

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/node3d.hpp>
#include <arviz_godot/lib/avi/interaction/RotateAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class None : public godot::Node3D
    {
        GDCLASS(None, Node3D)

    public:
        None() = default;
        virtual ~None() = default;

        static void _bind_methods();

        void setup(avi::interaction::Manipulator& manipulator, godot::Node3D* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Node3D* proxy;

        avi::scene::ElementNode* elementNode{};
    };
} // namespace avi::interaction
