#pragma once

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/node3d.hpp>
#include <arviz_godot/lib/avi/interaction/RotateAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class Rotate : public godot::Node3D
    {
        GDCLASS(Rotate, Node3D)

    public:
        Rotate() = default;
        virtual ~Rotate() = default;

        static void _bind_methods();

        void setup(avi::interaction::Manipulator& manipulator, godot::Node3D* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

        void updateTransform(const godot::Transform3D& local);
        void updateRelease();

        godot::Node3D* get_proxy();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Node3D* proxy{};

        avi::scene::ElementNode* elementNode{};

        avi::interaction::RotateAxisGizmo* XAxisGizmo{};
        avi::interaction::RotateAxisGizmo* YAxisGizmo{};
        avi::interaction::RotateAxisGizmo* ZAxisGizmo{};
    };
} // namespace avi::interaction
