#pragma once

#include <memory>
#include <optional>

#include <godot_cpp/classes/camera3d.hpp>
#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/static_body3d.hpp>
#include <arviz_godot/lib/avi/interaction/godot/Interaction.h>

namespace godot
{
    class Manipulator;
}

namespace avi::interaction
{
    class Rotate;

    class RotateAxisGizmo : public godot::StaticBody3D
    {
        GDCLASS(RotateAxisGizmo, StaticBody3D)

    public:
        static void _bind_methods();

        RotateAxisGizmo();
        virtual ~RotateAxisGizmo();

        void _input(godot::Ref<godot::InputEvent> const& event) override;

        void _input_event(godot::Camera3D* camera,
                          const godot::Ref<godot::InputEvent>& event,
                          const godot::Vector3& position,
                          const godot::Vector3& normal,
                          int32_t shape_idx) override;

        void setup(avi::interaction::Rotate& rotate, int axis);

        void setActive(bool activeStatus);

        void _process(double delta) override;

    private:
        bool moved = false;
        godot::Camera3D* camera;

        std::optional<godot::Interaction> data;

        avi::interaction::Rotate* rotate{};
        int axis = 0;

        std::unique_ptr<godot::Manipulator> manipulator;
    };

} // namespace avi::interaction
