#include <arviz_godot/lib/avi/core/Detoolifier.h>
#include "Scale.h"

#include "Manipulator.h"

void
avi::interaction::Scale::_bind_methods()
{
    DETOOLIFY;
}

void
avi::interaction::Scale::setup(avi::interaction::Manipulator& manipulator, godot::Node3D* proxy)
{
    DETOOLIFY;
    this->manipulator = &manipulator;
    this->proxy = proxy;

    this->XAxisGizmo = get_node<avi::interaction::ScaleAxisGizmo>("Scaler/X Axis");
    this->YAxisGizmo = get_node<avi::interaction::ScaleAxisGizmo>("Scaler/Y Axis");
    this->ZAxisGizmo = get_node<avi::interaction::ScaleAxisGizmo>("Scaler/Z Axis");

    XAxisGizmo->setup(*this, xAxis);
    YAxisGizmo->setup(*this, yAxis);
    ZAxisGizmo->setup(*this, zAxis);

    this->hide();
}

void
avi::interaction::Scale::targetElement(avi::scene::ElementNode& elementNode)
{
    DETOOLIFY;
    XAxisGizmo->setActive(false);
    YAxisGizmo->setActive(false);
    ZAxisGizmo->setActive(false);

    if (elementNode.scalingX())
    {
        XAxisGizmo->setActive(true);
    }

    if (elementNode.scalingY())
    {
        YAxisGizmo->setActive(true);
    }

    if (elementNode.scalingZ())
    {
        ZAxisGizmo->setActive(true);
    }

    this->elementNode = &elementNode;
    manipulator->setGizmoTransform(
        this, this->elementNode->getTransform(), this->elementNode->scalingLocal());
}

void
avi::interaction::Scale::deactivate()
{
    DETOOLIFY;
    this->hide();
}

void
avi::interaction::Scale::activate()
{
    DETOOLIFY;
    this->show();
}

void
avi::interaction::Scale::updateTransform(const godot::Transform3D& global,
                                         const godot::Transform3D& local)
{
    DETOOLIFY;
    auto selected = this->elementNode->scalingLocal() ? local : global;

    proxy->set_transform(selected);
    manipulator->sendManipulation();

    manipulator->scaleGizmo(this);
}

void
avi::interaction::Scale::updateRelease()
{
    DETOOLIFY;
    manipulator->endManipulation();
}

godot::Node3D*
avi::interaction::Scale::get_proxy()
{
    return this->proxy;
}

void
avi::interaction::Scale::_process(double delta)
{
    DETOOLIFY;

}
