#pragma once

#include <godot_cpp/godot.hpp>
#include <godot_cpp/classes/node3d.hpp>
#include <arviz_godot/lib/avi/interaction/ScaleAxisGizmo.h>
#include <arviz_godot/lib/avi/scene/ElementNode.h>

namespace avi::interaction
{
    class Manipulator;

    class Scale : public godot::Node3D
    {
        GDCLASS(Scale, Node3D)

    public:
        Scale() = default;
        virtual ~Scale() = default;

        static void _bind_methods();

        void _process(double delta) override;

        void setup(avi::interaction::Manipulator& manipulator, godot::Node3D* proxy);

        void targetElement(avi::scene::ElementNode& elementNode);

        void activate();

        void deactivate();

        void updateTransform(const godot::Transform3D& global, const godot::Transform3D& local);
        void updateRelease();

        godot::Node3D* get_proxy();

    private:
        avi::interaction::Manipulator* manipulator{};
        godot::Node3D* proxy{};

        avi::scene::ElementNode* elementNode{};

        avi::interaction::ScaleAxisGizmo* XAxisGizmo{};
        avi::interaction::ScaleAxisGizmo* YAxisGizmo{};
        avi::interaction::ScaleAxisGizmo* ZAxisGizmo{};

        godot::Vector3 scale = {};

        enum axis
        {
            xAxis = 0,
            yAxis = 1,
            zAxis = 2
        };
    };
} // namespace avi::interaction
