#pragma once

#include <chrono>
#include <iomanip>

#include <godot_cpp/classes/os.hpp>

#include <arviz_godot/lib/avi/core/EventSubscriptionSystem.h>
#include <arviz_godot/lib/avi/core/SettingsProvider.h>
#include <arviz_godot/lib/avi/scene/CameraSet.h>

namespace avi::recording
{
    class ImageRecorder
    {
    public:
        ImageRecorder(avi::scene::CameraSet& cameras,
                      avi::core::SettingsProvider& settings,
                      avi::core::EventSubscriptionSystem& events);

        void takeScreenshot();

        std::filesystem::path getLastScreenshotPath();

    private:
        std::filesystem::path lastScreenshotPath;

        avi::scene::CameraSet& cameras;
        avi::core::SettingsProvider& settings;
    };
} // namespace avi::recording
