#pragma once

#include <arviz_godot/lib/avi/scene/ViewCamera.h>

namespace avi::scene
{
    class ViewCamera;

    class CameraControlScheme
    {
    public:
        enum Axis
        {
            xAxis = 0,
            yAxis = 1,
            zAxis = 2,
        };

        enum AxisSign
        {
            positive = 0,
            negative = 1,
            signSwitch = 2,
        };

        enum RotationDirection
        {
            NEGATIVE_HORIZONTAL = 0,
            POSITIVE_HORIZONTAL = 1,
            NEGATIVE_VERTICAL = 2,
            POSITIVE_VERTICAL = 3,
        };

        enum HotkeyRotation
        {
            continuous,
            fixed,
            disable,
        };

        virtual void takeOver(avi::scene::ViewCamera* viewCamera, godot::Transform3D head) = 0;

        virtual godot::Transform3D release() = 0;

        virtual void reset() = 0;

        virtual void focus(godot::AABB box) = 0;

        virtual void focus(godot::Vector3 point, avi::core::Element*) = 0;

        virtual void placeOnAxis(godot::Vector3 fromVector) = 0;

        virtual void placeOnAxisNumpad(Axis axis, AxisSign sign) = 0;

        virtual void invertAxis(godot::Vector3 fromVector) = 0;

        virtual void rotateFixed(RotationDirection direction, HotkeyRotation hotkey) = 0;

        virtual godot::Basis getRotationBasis() = 0;

        virtual void setupControlAdvertisements(avi::core::ControlAdvertiser& advertiser) = 0;

        virtual ~CameraControlScheme() = default;
    };
} // namespace avi::scene
