#pragma once

#include "MeshElementNode.h"

#include <godot_cpp/classes/box_mesh.hpp>

namespace avi::scene
{
    class CubeElementNode : public avi::scene::MeshElementNode
    {
        GDCLASS(CubeElementNode, ElementNode)

    public:
        static void _bind_methods();

        CubeElementNode() = default;
        ~CubeElementNode() override = default;

        void _ready() override;

        static avi::scene::CubeElementNode* newCubeElementNode(std::string name,
                                                               avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        godot::Vector3 size;
    };
} // namespace avi::scene
