#pragma once

#include <godot_cpp/classes/mesh.hpp>
#include <arviz_godot/lib/avi/scene/MeshElementNode.h>

namespace avi::scene
{
    class CustomMeshElementNode : public avi::scene::MeshElementNode
    {
        GDCLASS(CustomMeshElementNode, avi::scene::MeshElementNode)

    public:
        static void _bind_methods();

        CustomMeshElementNode() = default;
        ~CustomMeshElementNode() override = default;

        void _ready() override;

        static CustomMeshElementNode*
        newCustomMeshElementNode(godot::Mesh* mesh,
                                 avi::connection::SentElementType type,
                                 std::string name,
                                 avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        bool first = true;
    };
} // namespace avi::scene
