#include <arviz_godot/lib/avi/core/Detoolifier.h>
#include "CylinderElementNode.h"

#include <utility>

#include "Converter.h"

#include <godot_cpp/classes/cylinder_shape3d.hpp>

void
avi::scene::CylinderElementNode::_bind_methods()
{
    DETOOLIFY;

}

void
avi::scene::CylinderElementNode::_ready()
{
    DETOOLIFY;
}

void
avi::scene::CylinderElementNode::update(IceInternal::Handle<armarx::viz::data::Element> elementInfo)
{
    DETOOLIFY;
    auto cylinder =
        IceInternal::Handle<armarx::viz::data::ElementCylinder>::dynamicCast(elementInfo);

    if (!godot::Math::is_equal_approx(height, cylinder->height) ||
        !godot::Math::is_equal_approx(radius, cylinder->radius))
    {
        radius = cylinder->radius;
        height = cylinder->height;

        getMeshInstance()->set_scale({radius, height / 2, radius});
        getCollisionShape()->set_scale({radius, height / 2, radius});
    }

    updateAttributes(cylinder->interaction.enableFlags,
                     cylinder->interaction.contextMenuOptions,
                     avi::scene::Converter::getPosition(cylinder->pose),
                     avi::scene::Converter::getScale(cylinder->scale),
                     avi::scene::Converter::getRotation(cylinder->pose),
                     avi::scene::Converter::getColor(cylinder->color));
}

avi::scene::CylinderElementNode*
avi::scene::CylinderElementNode::newCylinderElementNode(std::string name, avi::core::Layer* layer)
{
    CylinderElementNode* node = memnew(CylinderElementNode);
    godot::Mesh* mesh = memnew(godot::CylinderMesh);

    node->setStartAttributes(
        mesh, avi::connection::SentElementType::CYLINDER, std::move(name), layer);

    node->setShape(memnew(godot::CylinderShape3D));

    return node;
}
