#pragma once

#include "MeshElementNode.h"

#include <godot_cpp/classes/cylinder_mesh.hpp>

namespace avi::scene
{
    class CylinderElementNode : public avi::scene::MeshElementNode
    {
        GDCLASS(CylinderElementNode, ElementNode)

    public:
        static void _bind_methods();

        CylinderElementNode() = default;
        ~CylinderElementNode() override = default;

        void _ready() override;

        static CylinderElementNode* newCylinderElementNode(std::string name,
                                                           avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        float height = 0.0f;
        float radius = 0.0f;
    };
} // namespace avi::scene
