#pragma once

#include "MeshElementNode.h"

#include <godot_cpp/classes/sphere_mesh.hpp>

namespace avi::scene
{
    class EllipsoidElementNode : public avi::scene::MeshElementNode
    {
        GDCLASS(EllipsoidElementNode, ElementNode)

    public:
        static void _bind_methods();

        EllipsoidElementNode() = default;
        ~EllipsoidElementNode() override = default;

        void _ready() override;

        static EllipsoidElementNode* newEllipsoidElementNode(std::string name,
                                                             avi::core::Layer* layer);

        void update(IceInternal::Handle<armarx::viz::data::Element> elementInfo) override;

    private:
        godot::Vector3 scale;
    };
} // namespace avi::scene
