#pragma once

#include "ElementNode.h"

#include <godot_cpp/godot.hpp>
#include <godot_cpp/variant/dictionary.hpp>
#include <godot_cpp/classes/physics_direct_space_state3d.hpp>
#include <godot_cpp/classes/sub_viewport.hpp>

#include <arviz_godot/lib/avi/core/EventInvokingSystem.h>
#include <arviz_godot/lib/avi/scene/CameraControlScheme.h>
#include <arviz_godot/lib/avi/scene/PoseElementNode.h>
#include <arviz_godot/lib/avi/scene/VisualizedScene.h>

namespace avi::scene
{
    class OrientationIndicator : public godot::SubViewport
    {
        GDCLASS(OrientationIndicator, godot::SubViewport)

    public:
        static void _bind_methods();

        OrientationIndicator();
        ~OrientationIndicator() = default;

        void _process(double delta) override;

        void _ready() override;

        void selectElement();

        void _input(godot::Ref<godot::InputEvent> const& event) override;

        void setup(avi::scene::VisualizedScene* scene,
                   avi::scene::ViewCamera* viewCamera,
                   avi::core::EventInvokingSystem& events);

    private:
        struct OrientationIndicatorPoint
        {
            godot::Node3D* spatial;
            CameraControlScheme::Axis axis;
        };

        avi::scene::VisualizedScene* scene;
        avi::scene::ViewCamera* viewCamera;
        godot::Camera3D* camera;
        godot::StaticBody3D* pose;

        std::vector<OrientationIndicatorPoint> points{};

        avi::core::EventInvokingSystem* events = nullptr;
    };
} // namespace avi::scene
