#pragma once

#include <optional>

#include <arviz_godot/lib/avi/core/SettingsProvider.h>
#include <arviz_godot/lib/avi/scene/Profile.h>

namespace avi::scene
{
    class ProfileStorage
    {
    public:
        explicit ProfileStorage(const avi::core::SettingsProvider& settingsProvider);

        std::optional<avi::scene::Profile> retrieveDefault();

        avi::scene::Profile createDefault();

        std::vector<std::string> getNames();

        bool has(const std::string& name);

        std::optional<avi::scene::Profile> retrieve(const std::string& name);

        void put(avi::scene::Profile profile);

        void save(avi::scene::Profile& profile);

        void cleanup();

    private:
        avi::core::OptionFile& getOptionFile(const std::string& name);

    private:
        const avi::core::SettingsProvider& settingsProvider;
        std::map<std::string, avi::core::OptionFile> files{};
        std::map<std::string, avi::scene::Profile> profiles{};
    };
} // namespace avi::scene
