#include <arviz_godot/lib/avi/core/Detoolifier.h>
#include "SphereElementNode.h"

#include <godot_cpp/classes/sphere_mesh.hpp>
#include <godot_cpp/classes/sphere_shape3d.hpp>

#include <arviz_godot/lib/avi/scene/Converter.h>

void
avi::scene::SphereElementNode::_bind_methods()
{
    DETOOLIFY;

}

void
avi::scene::SphereElementNode::_ready()
{
    DETOOLIFY;
}

void
avi::scene::SphereElementNode::update(IceInternal::Handle<armarx::viz::data::Element> elementInfo)
{
    DETOOLIFY;
    auto sphere = IceInternal::Handle<armarx::viz::data::ElementSphere>::dynamicCast(elementInfo);

    float newRadius = sphere->radius;

    if (!godot::Math::is_equal_approx(radius, newRadius))
    {
        radius = newRadius;

        getMeshInstance()->set_scale({radius, radius, radius});
        getCollisionShape()->set_scale({radius, radius, radius});
    }


    updateAttributes(sphere->interaction.enableFlags,
                     sphere->interaction.contextMenuOptions,
                     avi::scene::Converter::getPosition(sphere->pose),
                     avi::scene::Converter::getScale(sphere->scale),
                     avi::scene::Converter::getRotation(sphere->pose),
                     avi::scene::Converter::getColor(sphere->color));
}

avi::scene::SphereElementNode*
avi::scene::SphereElementNode::newSphereElementNode(std::string name, avi::core::Layer* layer)
{
    SphereElementNode* node = memnew(SphereElementNode);
    godot::Mesh* mesh = memnew(godot::SphereMesh);

    node->setStartAttributes(mesh, avi::connection::SentElementType::SPHERE, name, layer);
    node->setShape(memnew(godot::SphereShape3D));

    return node;
}
